         JMP   START

         DB    0Dh,0Ah
         DB    'Fix-Flop 1.0 A utility to Reset Disk Drives on',0Dh,0Ah 
         DB    'DOS ERRORS and Report Errors as Necessary',0Dh,0Ah
         DB    'Copyright (C) 1990 by Ed Derzawiec',0Dh,0Ah
         DB    '6 Sweet Fern Rd, Cape Elizabeth, ME  04107',0Dh,0Ah
         DB    'DECLARED PUBLIC DOMAIN'
         DB    1Ah           ;Clean up a listing of this .COM file


DSPLINE  MACRO               ;Displays the null (0) terminated line at #1
         MOV   DI,OFFSET(#1)
         CALL  DSPASCIZ
         #EM
         
         PROC  NEAR
DSPASCIZ:PUSH  DI            ;This routine Displays the ASCIIZ String at DI
DspASC1: MOV   AH,0E
         SUB   BX,BX
         MOV   AL,[DI]
         CMP   AL,0
         JE    DspASC9
         INT   10h
         INC   DI
         JMP   DspASC1
DspASC9: POP   DI
         RET
         ENDP

;************************ BIOS ERROR MESSAGES *********************************
NoError: DB    'No Error Reported from Disk Controller on last Operation',0
NoErrorR:DB    'No Error in Resetting Disk',0
Error01: DB    'Bad Command Passed to Controller',0
Error02: DB    'Address Mark Not Found',0
Error03: DB    'Write Attempted to Protected Disk',0
Error04: DB    'Sector Not Found',0
Error05: DB    'Reset Failed',0
Error06: DB    'Diskette Removed',0
Error07: DB    'Bad Disk parameter Table',0
Error08: DB    'DMA Overrun',0
Error09: DB    'DMA accross 64K Boundry',0
Error0A: DB    'Bad Sector Flag seen',0
Error0B: DB    'Bad Track Flag Seen',0
Error010: DB   'Bad CRC Error Chech seen',0
Error011: DB   'Data is Error Corrected',0
Error020: DB   'Controller Failure',0
Error040: DB   'Seek Operation Failed',0
Error080: DB   'No Responce within Time Out Error',0
Error0AA: DB   'Drive Not Ready',0
Error0BB: DB   'Undefined Drive Error',0
Error0CC: DB   'Write Fault',0
Error0E0: DB   'Status Error',0
Error0FF: DB   'Sense Fault',0
ErrorNone:DB   'Not a BIOS Reported Error',0
CRLF:     DB    0Dh,0Ah,0


TypeError:
         CMP   AH,01
         JNE   Next01
         DSPLINE Error01
         RET
Next01:  CMP   AH,02
         JNE   Next02
         DSPLINE Error02
         RET
Next02:  CMP   AH,03
         JNE   Next03
         DSPLINE Error03
         RET
Next03:  CMP   AH,04
         JNE   Next04
         DSPLINE Error04
         RET
Next04:  CMP   AH,05
         JNE   Next05
         DSPLINE Error05
         RET
Next05:  CMP   AH,06
         JNE   Next06
         DSPLINE Error06
         RET
Next06:  CMP   AH,07
         JNE   Next07
         DSPLINE Error07
         RET
Next07:  CMP   AH,08
         JNE   Next08
         DSPLINE Error08
         RET
Next08:  CMP   AH,09
         JNE   Next09
         DSPLINE Error09
         RET
Next09:  CMP   AH,0A
         JNE   Next0A
         DSPLINE Error0A
         RET
Next0A:  CMP   AH,0B
         JNE   Next0B
         DSPLINE Error0B
         RET
Next0B:  CMP   AH,010
         JNE   Next010
         DSPLINE Error010
         RET
Next010: CMP   AH,011
         JNE   Next011
         DSPLINE Error011
         RET
Next011: CMP   AH,020
         JNE   Next020
         DSPLINE Error020
         RET
Next020: CMP   AH,040
         JNE   Next040
         DSPLINE Error040
         RET
Next040: CMP   AH,080
         JNE   Next080
         DSPLINE Error080
         RET
Next080: CMP   AH,0AA
         JNE   Next0AA
         DSPLINE Error0AA
         RET
Next0AA: CMP   AH,0BB
         JNE   Next0BB
         DSPLINE Error0BB
         RET
Next0BB: CMP   AH,0CC
         JNE   Next0CC
         DSPLINE Error0CC
         RET
Next0CC: CMP   AH,0E0
         JNE   Next0E0
         DSPLINE Error0E0
         RET
Next0E0: CMP   AH,0FF
         JNE   Next0FF
         DSPLINE Error0FF
         RET
Next0FF: CMP   AH,0FF
         JNE   NextNone
         DSPLINE Error0FF
         RET
NextNone:DSPLINE ErrorNone                           
         RET

;****************************  THE PROGRAM  ***********************************
         DB    'Pgm Start'   ;Debug Aid
START:   MOV   AH,01
         MOV   DL,00         ;< 80h for floppies, >= 80 for Hard disks
         INT   13h           ;Get Disk Status of Last Operation
         CMP   AH,0
         JNE   DspErr        ;Check for possible error
         DSPLINE NoError     ;
         DSPLINE CrLf
         JMP   Reset         ;Reset Disk Anyway

DspErr:  CALL TypeError      ;Display Last Operation Error
         DSPLINE CrLf
Reset:   SUB   AH,AH
         SUB   DL,DL
         INT   13h           ;Reset Drive
         JC    DspErr1
         DSPLINE NoErrorR
         JMP   Exit

DspErr1: CMP   AH,0
         JNE   DspErr2       ;Display Reset Error
         DSPLINE NoErrorR
         JMP   Exit          ;False Alarm, No Reported Error

DspErr2: CALL TypeError

Exit:    SUB   AH,AH
         INT   21h           ;Exit Program

